Subject: bug#34427: [email-masked] segfault?

From: Ludovic Courtès <[email-masked]>
Date: Tue, 12 Apr 2022 18:01:39 +0200

Hi,

Efraim Flashner <[email-masked]> skribis:

> On Tue, Feb 12, 2019 at 03:27:37PM +0100, Ludovic Courtès wrote:
>> Hello Efraim,
>> 
>> Efraim Flashner <[email-masked]> skribis:
>> 
>> > I'm testing %bootstrap-guile from bootstrap.scm and I'm getting a
>> > segfault when runing guile --version. I've attached an strace of the
>> > process.
>> 
>> To be clear, I believe this is for a *cross-compiled* Guile, right?
>
> That's right, %bootstrap-guile is extracted from $(guix build
> --target=powerpc-linux-gnu bootstrap-tarballs)

Cross-compilation to aarch64-linux-gnu works fine:

--8<---------------cut here---------------start------------->8---
$ unshare -mrf chroot $(guix build guile-static-stripped --target=aarch64-linux-gnu) /bin/guile
guile: warning: failed to install locale
GC Warning: pthread_getattr_np or pthread_attr_getstack failed for main thread
GC Warning: Couldn't read /proc/stat
warning: failed to install locale: Invalid argument
GNU Guile 3.0.7
Copyright (C) 1995-2021 Free Software Foundation, Inc.

Guile comes with ABSOLUTELY NO WARRANTY; for details type `,show w'.
This program is free software, and you are welcome to redistribute it
under certain conditions; type `,show c' for details.

Enter `,help' for help.
scheme@(guile-user)> %host-type
$1 = "aarch64-unknown-linux-gnu"
scheme@(guile-user)> ,q
$ guix describe
Generation 210  Apr 11 2022 09:34:10    (current)
  guix 7da907f
    repository URL: https://git.savannah.gnu.org/git/guix.git
    branch: master
    commit: 7da907f90e74a4edf96d76ee457ff958265ef8d4
--8<---------------cut here---------------end--------------->8---

The problem has to do specifically with powerpc-linux-gnu (this is with
transparent emulation via QEMU+binfmt_misc):

--8<---------------cut here---------------start------------->8---
$ unshare -mrf chroot $(guix build guile-static-stripped --target=powerpc-linux-gnu) /bin/guile
guile: warning: failed to install locale
GC Warning: pthread_getattr_np or pthread_attr_getstack failed for main thread
GC Warning: Couldn't read /proc/stat
Pre-boot error; key: wrong-type-arg, args: (#f "Wrong type to apply: ~S" (#f) (#f))qemu: uncaught target signal 6 (Aborted) - core dumped
Aborted
--8<---------------cut here---------------end--------------->8---

Unfortunately I fail to get a backtrace from that core dump.

Efraim, could you get a backtrace on the bare metal?

Besides, if PPC32 is the only platform that has a problem, I think this
bug should not be a blocker.

WDYT?

Ludo’.